#include <windows.h>
#include "ChannelList.h"




class CChannelInfo {
public:
	CChannelInfo(int Space,int Channel,int No,LPCTSTR pszName);
	int m_Space;
	int m_Channel;
	int m_ChannelNo;
	TCHAR m_szName[MAX_CHANNEL_NAME];
};


CChannelInfo::CChannelInfo(int Space,int Channel,int No,LPCTSTR pszName)
{
	m_Space=Space;
	m_Channel=Channel;
	m_ChannelNo=No;
	lstrcpyn(m_szName,pszName,MAX_CHANNEL_NAME);
}




CChannelList::CChannelList()
{
	m_NumChannels=0;
	m_ppList=NULL;
	m_ChannelOffset=0;
}


CChannelList::~CChannelList()
{
	int i;

	for (i=m_NumChannels-1;i>=0;i--)
		delete m_ppList[i];
	free(m_ppList);
}


bool CChannelList::AddChannel(int Space,int Channel,int No,LPCTSTR pszName)
{
	m_ppList=(CChannelInfo**)realloc(m_ppList,
									(m_NumChannels+1)*sizeof(CChannelInfo*));
	m_ppList[m_NumChannels++]=new CChannelInfo(Space,Channel,No,pszName);
	return true;
}


int CChannelList::GetSpace(int No) const
{
	return m_ppList[No]->m_Space;
}


int CChannelList::GetChannel(int No) const
{
	return m_ppList[No]->m_Channel;
}


int CChannelList::GetChannelNo(int No) const
{
	return m_ppList[No]->m_ChannelNo;
}


int CChannelList::GetChannelIndex(int No) const
{
	int Index;

	Index=m_ppList[No]->m_Channel-m_ChannelOffset;
	return Index;
}


LPCTSTR CChannelList::GetName(int No) const
{
	return m_ppList[No]->m_szName;
}


bool CChannelList::SetChannelOffset(int Offset)
{
	m_ChannelOffset=Offset;
	return true;
}
